<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\FPA\Repository\ValorReferenciaRepository;

class ValorReferenciaService {

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, ValorReferenciaRepository $valorReferenciaRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->valorReferenciaRepository = $valorReferenciaRepository;
    }

    public function getSalarioMinimo() {
        $dtcompetencia = $this->hcmParameters->getDtCompetencia();
        $historicos = $this->entityManager->createQueryBuilder()
            ->select('vh')
            ->from(Repositories::FPA_VALORREFERENCIAH, 'vh')
            ->where('vh.nrvalorreferenciam = :nrvalorreferenciam and vh.dtmescompetenc <= :dtmescompetenc')
            ->orderBy('vh.dtmescompetenc', 'DESC')
            ->getQuery()
            ->execute(array('nrvalorreferenciam' => 1, 'dtmescompetenc' => DateUtil::getDataDeString($dtcompetencia)));
        return $historicos[0];
    }
    
    public function getReferenciaPorDescricao($referencia, $nrorg, $dtmescompetenc, $descricao){
        return $this->valorReferenciaRepository->getReferenciaPorDescricao($referencia, $nrorg, $dtmescompetenc, $descricao);
    }
    
    public function getReferenciaPorNrValorReferencia($nrorg, $dtmescompetenc, $nrValorReferencia) { 
        return $this->valorReferenciaRepository->getReferenciaPorNrValorReferencia($nrorg, $dtmescompetenc, $nrValorReferencia);
    }

} 