<?php
namespace HCM\SST\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class AgenteCausadorRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function validaRestricaoChavePrimaria($cdESocial, $nrorg, $nrorgPadrao, $chaveSiMesma = null) {
        $query = "
                SELECT 
                    COUNT(*)
                FROM SST_AGENTCAUSAD
                WHERE CDESOCIAL = :CDESOCIAL
                 AND (NRORG = :NRORG OR NRORG = :NRORG_PADRAO)
                 AND (NRAGENTCAUSAD <> :NRAGENTCAUSAD OR :NRAGENTCAUSAD IS NULL)
        ";

        
        $parameters = 
        [
            "NRORG"         => $nrorg,
            "NRORG_PADRAO"  => $nrorgPadrao,
            "CDESOCIAL"     => $cdESocial,
            "NRAGENTCAUSAD" => $chaveSiMesma,
        ];
        
        $result = $this->connection->fetchAssoc($query, $parameters);
        if($result['COUNT(*)'] > 0) 
            return true;
        else
            return false;
    }

} 

