<?php

namespace HCM\VAB\Services;

use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\FPA\Entity\FpatipocalculoEntity;

class MemoriaBeneficio{

    private static $instance = null;
    private static $contador = 0;
    
    private $nomeArquivo = null;
    private $escopoGeral = "";
    private $escopoVinc = null;
    
    private $resultadoTotal;
    
    private $referencia;
    
    private $infoBenefVinc = [];
    private $infoCalculo = [];
    
    private $vinculo;
    private $dtPagamento;

    private $arquivo;
    
    public function inicializarDados($vinculo, $hcmParameters, $dtPagamento){
       
        $this->resultadoTotal = null;
        
        $this->infoBenefVinc = [];
        $this->infoCalculo = [];
        
        $this->vinculo = $vinculo;
        $this->dtPagamento = $dtPagamento;
    }
    
    public function setInfoBenefVinc($infos){
        $this->infoBenefVinc[] = $infos;
    }
    
    public function setCalcBenefVinc($evento, $vlrBeneficio, $calculoBeneficio, $proporcao, $vlrMultiplicador, $vlrPisoMens, $vlrTetoMens, $nrtabelafolha = null, $tipo = null, $referencia = null){
        
        $msg = 
            PHP_EOL.PHP_EOL.
            'Evento: '.$evento.PHP_EOL.
            'Valor: '.$vlrBeneficio.PHP_EOL.
            'Proporcao: '.$proporcao.PHP_EOL.
            'Vr multiplicador: '.$vlrMultiplicador.PHP_EOL.
            'Referencia: '.$referencia.PHP_EOL.
            'Piso: '.$vlrPisoMens.PHP_EOL.
            'Teto: '.$vlrTetoMens.PHP_EOL.
            'Tabela: '.$nrtabelafolha.PHP_EOL.
            'Tipo: '.$tipo.PHP_EOL.
            'Calculo: '.$calculoBeneficio.PHP_EOL
        ;
        
        $this->infoCalculo[] = $msg;
    }

    public static function getInstance() {
        if (self::$instance === null) {
            self::$contador++;
            self::$instance = new self();
        }

        return self::$instance;
    }

    public function clear()
    {
        self::$instance = null;
        self::$contador = 0;
    }
    

    public function getCaminhoArquivo(){
        return $this->arquivo;
    }
    
    public function concatenarMensagemVinc(){
        $escopoVinc = 
        PHP_EOL.PHP_EOL.
        '=-=-=-=-=-=-=- INFORMAÇÃO '.self::$contador.' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-='.PHP_EOL.PHP_EOL.
        '_______________ ::::: Dados do vínculo'.PHP_EOL.PHP_EOL.    
        '* Nr. Vínculo: '.$this->vinculo->getNrvinculom().PHP_EOL.
        '* Nome Vínculo: '.$this->vinculo->getNmvinculom().PHP_EOL.
        '* Data Pagamento: '.$this->dtPagamento.PHP_EOL
        ;
        
        $escopoVinc .=
        '_______________ ::::: Informações do Beneficio'
        ;    
        
        if(count($this->infoBenefVinc) > 0){
            foreach($this->infoBenefVinc as $key=> $infoBenef){
                $msg = 
                PHP_EOL.PHP_EOL.
                'Beneficio '.$infoBenef['DSBENEFICIO'].': '.PHP_EOL.
                'Tipo Período: '.$infoBenef['TPPERIODOBENEF'].PHP_EOL.
                'Tipo Benefício: '.$infoBenef['NRTPBENEFICIO'].PHP_EOL.
                'Dt inicio vigencia: '.$infoBenef['DTINICIOVIGENCIA'].PHP_EOL.
                'Dt fim vigencia: '.$infoBenef['DTFINALVIGENCIA'].PHP_EOL.
                'Estrutura: '.$infoBenef['NRESTRUTURAM'].PHP_EOL.
                'Forma Beneficio: '.$infoBenef['NRFORMABENEFICIO'].PHP_EOL.
                'Dias Mes: '.$infoBenef['DIASTRABALHADOSTOTAL'].PHP_EOL.
                'Dias Faltas: '.$infoBenef['DIASFALTAS'].PHP_EOL.
                'Dias Atestado: '.$infoBenef['DIASATESTADO'].PHP_EOL.
                'Dias Trabalhados ('.$infoBenef['DIASTRABALHADOSTOTAL'].' - '.$infoBenef['DIASFALTAS'].') = '.$infoBenef['DIASTRABALHADOS'].PHP_EOL
                ;

                $escopoVinc .= $msg;
            }
        }else{
            $escopoVinc .= PHP_EOL.PHP_EOL."NENHUM BENEFICIO ENCONTRADO".PHP_EOL;
        }
        

        $escopoVinc .= PHP_EOL.PHP_EOL.
        '_______________ ::::: Detalhes do cálculo'
        ;    
        
        if(count($this->infoCalculo) > 0){
            foreach($this->infoCalculo as $key=>$msg){
                $escopoVinc .= $msg;
            }
        }else{
            $escopoVinc .= PHP_EOL.PHP_EOL."NENHUM CALCULO ENCONTRADO".PHP_EOL;
        } 
       
        $this->unirEscopoVincEscopoGeral($escopoVinc);
        
        self::$contador++;

    }
    
    public function unirEscopoVincEscopoGeral($escopoVinc){
        $this->escopoGeral .= $escopoVinc;
    }
    
    public function prepararDetalhesDiasPeriodoCalc(){

        if($this->detalhesDiasConsPeriodo['tipo'] == 'turno'){
            $retorno =
            PHP_EOL.PHP_EOL.
            '_____ ::::: Detalhamento dias Consideração do Período'.PHP_EOL.PHP_EOL.
            '* Fórmula: '.$this->detalhesDiasConsPeriodo['formula'].PHP_EOL.
            '* Expressão: '.$this->detalhesDiasConsPeriodo['expressao'].PHP_EOL.
            '* Resultado: '.$this->detalhesDiasConsPeriodo['resultado'].PHP_EOL.
            '* qtdeDiasTrabalhados (desconsiderando folgas): '.$this->detalhesDiasConsPeriodo['qtdeDiasTrabalhados'].PHP_EOL.
            '* feriados: '.$this->detalhesDiasConsPeriodo['feriados'].PHP_EOL.
            '* intersecaoFolgaFeriado: '.$this->detalhesDiasConsPeriodo['intersecaoFolgaFeriado'].PHP_EOL
            ;
        }elseif($this->detalhesDiasConsPeriodo['tipo'] == 'dsr'){
            $retorno =
            PHP_EOL.PHP_EOL.
            '_____ ::::: Detalhamento dias Consideração do Período'.PHP_EOL.PHP_EOL.
            '* Fórmula: '.$this->detalhesDiasConsPeriodo['formula'].PHP_EOL.
            '* Expressão: '.$this->detalhesDiasConsPeriodo['expressao'].PHP_EOL.
            '* Resultado: '.$this->detalhesDiasConsPeriodo['resultado'].PHP_EOL.
            '* diasPeriodo: (considerando dsr) '.$this->detalhesDiasConsPeriodo['diasPeriodo'].PHP_EOL.
            '* dsr: '.$this->detalhesDiasConsPeriodo['dsr'].PHP_EOL.
            '* feriados: '.$this->detalhesDiasConsPeriodo['feriados'].PHP_EOL.
            '* intersecaoDsrFeriado : '.$this->detalhesDiasConsPeriodo['intersecaoDsrFeriado'].PHP_EOL
            ;
        }
        
        return $retorno;

    }
    
    public function prepararDetalhesAtestAfast(){
        $retorno = "";
        
        if(count($this->detalhesAfastAtest) > 0) $retorno = PHP_EOL.PHP_EOL.'_____ Detalhamento atestado/afastamento'.PHP_EOL.PHP_EOL;
        
        foreach($this->detalhesAfastAtest as $key => $detalheAfastAtest){
            if($detalheAfastAtest['tipo'] == 'turno'){
                $retorno .=
                '__ Atest/Afast '.($key+1).PHP_EOL.
                '* Dt. Inicial: '.$detalheAfastAtest['dtInicial'].PHP_EOL.
                '* Dt. Final: '.$detalheAfastAtest['dtFinal'].PHP_EOL.
                '* Fórmula: '.$detalheAfastAtest['formula'].PHP_EOL.
                '* Expressão: '.$detalheAfastAtest['expressao'].PHP_EOL.
                '* Resultado: '.$detalheAfastAtest['resultado'].PHP_EOL.
                '* diasTotaisAtestOuAfast: '.$detalheAfastAtest['diasTotaisAtestOuAfast'].PHP_EOL.
                '* feriados: '.$detalheAfastAtest['feriados'].PHP_EOL.
                '* diasFolga: '.$detalheAfastAtest['diasFolga'].PHP_EOL.
                '* intersecaoFolgaFeriado: '.$detalheAfastAtest['intersecaoFolgaFeriado'].PHP_EOL.PHP_EOL
                ;
            }elseif($detalheAfastAtest['tipo'] == 'dsr'){
                $retorno .=
                '__ Atest/Afast '.($key+1).PHP_EOL.
                '* Dt. Inicial: '.$detalheAfastAtest['dtInicial'].PHP_EOL.
                '* Dt. Final: '.$detalheAfastAtest['dtFinal'].PHP_EOL.
                '* Fórmula: '.$detalheAfastAtest['formula'].PHP_EOL.
                '* Expressão: '.$detalheAfastAtest['expressao'].PHP_EOL.
                '* Resultado: '.$detalheAfastAtest['resultado'].PHP_EOL.
                '* diasTotaisAtestOuAfast: '.$detalheAfastAtest['diasTotaisAtestOuAfast'].PHP_EOL.
                '* feriados: '.$detalheAfastAtest['feriados'].PHP_EOL.
                '* dsr: '.$detalheAfastAtest['dsr'].PHP_EOL.
                '* intersecaoDsrFeriado: '.$detalheAfastAtest['intersecaoDsrFeriado'].PHP_EOL.PHP_EOL
                ;
            }
        }
        
        return $retorno;

    }
    
    public function prepararDetalhesFerias(){
        $retorno = "";
        
        if($this->detalhesFerias['tipo'] == 'turno'){
            $retorno =
            PHP_EOL.PHP_EOL.
            '_____ Detalhamento Férias'.PHP_EOL.PHP_EOL.
            '* Fórmula: '.$this->detalhesFerias['formula'].PHP_EOL.
            '* Expressão: '.$this->detalhesFerias['expressao'].PHP_EOL.
            '* Resultado: '.$this->detalhesFerias['resultado'].PHP_EOL.
            '* totalFerias: '.$this->detalhesFerias['totalFerias'].PHP_EOL.
            '* diasFolgaVinc: '.$this->detalhesFerias['diasFolgaVinc'].PHP_EOL.
            '* feriados: '.$this->detalhesFerias['feriados'].PHP_EOL.
            '* intersecaoFolgaFeriado: '.$this->detalhesFerias['intersecaoFolgaFeriado'].PHP_EOL
            ;
        }elseif($this->detalhesFerias['tipo'] == 'dsr'){
            $retorno =
            PHP_EOL.PHP_EOL.
            '_____ Detalhamento Férias'.PHP_EOL.PHP_EOL.
            '* Fórmula: '.$this->detalhesFerias['formula'].PHP_EOL.
            '* Expressão: '.$this->detalhesFerias['expressao'].PHP_EOL.
            '* Resultado: '.$this->detalhesFerias['resultado'].PHP_EOL.
            '* totalFerias: '.$this->detalhesFerias['totalFerias'].PHP_EOL.
            '* dsr: '.$this->detalhesFerias['dsr'].PHP_EOL.
            '* feriados: '.$this->detalhesFerias['feriados'].PHP_EOL.
            '* intersecaoDsrFeriado: '.$this->detalhesFerias['intersecaoDsrFeriado'].PHP_EOL
            ;
        }
        
        return $retorno;

    }
    
    public function retornarMensagemCompleta(){
        return $this->escopoGeral;
    }
    
    public function retornarMensagemVinc(){
        return $this->escopoVinc;
    }
    
    public function salvarMsgArquivo(){
        $this->arquivo = FPA::getTempDirectory().'/Memoria_Beneficio  Execucao('.DateUtil::getDataAtual()->format('d-m-Y H:i:s').').txt';
        file_put_contents($this->arquivo, $this->escopoGeral);
    }

}