<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenner
 * Date: 17/01/14
 * Time: 13:23
 */

namespace Folha\Facade\Relatorios;


class Confidencial {
    /**
     * @param $SelConf
     * @return string
     * Método que gera um fragmento de query para a questão do tratamento de listagem de vínculo confidênciais
     * USO: No final da passagem de valores para o array de parâmetros do birt. Inserir este código: $params['P_CONFIDENCIAL'] = setQueryConfidencial('nao_conf');
     * 
     */
    public static function setQueryConfidencial($SelConf = null) {
        //const QRY_CONF_RESTR = "VH.CONFIDENCIAL = 'N'";				//Fragmento de query que apenas selecionas vínculos não confidênciais
        //const QRY_CONF_AUTOR = "(VH.CONFIDENCIAL = 'S' OR 1 = 1)";	//Fragmento de query que seleciona vínculos confidênciais e não confidenciais. (OBS.: Não esquecer os parênteses; o 'S' e o 'N' devem ficar entre aspas simples)
        if(tk_get_env_var('RESTRINGE_CONFIDENCIAL') == 'S') {   //Restringe confidencial - Somente vínculos não confidênciais
            return "VH.CONFIDENCIAL = 'N'";     //Fragmento de query que apenas seleciona vínculos não confidênciais
        } else {                                //Vínculos confidênciais e não confidenciais
            if($SelConf == null) {              //Caso o campo esteja vazio seguirá o padrão: apenas vínculos não confidênciais
                return "VH.CONFIDENCIAL = 'N'"; //Fragmento de query que apenas selecionas vínculos não confidênciais
            }
            switch($SelConf) {                 //Seleciona o tipo de vínculo a ser exibido
                case 'tudo':
                    return "(VH.CONFIDENCIAL = 'S' OR 1 = 1)";  //Fragmento de query que seleciona vínculos confidênciais e não confidenciais. (OBS.: Não esquecer os parênteses; o 'S' e o 'N' devem ficar entre aspas simples)
                    break;
                case 'nao_conf':
                case null:
                    return "VH.CONFIDENCIAL = 'N'";             //Fragmento de query que apenas selecionas vínculos não confidênciais
                    break;
                case 'som_conf':
                    return "VH.CONFIDENCIAL = 'S'";             //Fragmento de query que seleciona apenas vínculos confidenciais.
                    break;
                default:
                    tk_warning('A função setQueryConfidencial() recebeu um parâmetro inválido: '.$SelConf);
            } //fim do switch
        }
    }
} 