/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUTPAR_TIPOAJRECEBER                                        */
/* Tabela : TIPOAJRECEBER                                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 26/02/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATUTPAR_TIPOAJRECEBER' and
            type = 'TR'                           and
            u.uid = o.uid           	          and
            u.name = USER)
   DROP TRIGGER DTULTATUTPAR_TIPOAJRECEBER
GO

CREATE TRIGGER DTULTATUTPAR_TIPOAJRECEBER
ON TIPOAJRECEBER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOAJRECEBER', null, 'CDAJUCTREC=' + CDAJUCTREC + ';',                               GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE TIPOAJRECEBER
      SET DTULTATUTPAR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOAJRECEBER.CDAJUCTREC,0  ) = ISNULL(INSERTED.CDAJUCTREC,0  )) AND                      (ISNULL(TIPOAJRECEBER.CDHISTPADR,0  ) = ISNULL(INSERTED.CDHISTPADR,0  )) AND
            (ISNULL(TIPOAJRECEBER.CDCONTCTBL,0  ) = ISNULL(INSERTED.CDCONTCTBL,0  )) AND
            (ISNULL(TIPOAJRECEBER.DSAJUCTREC,0  ) = ISNULL(INSERTED.DSAJUCTREC,0  )) AND
            (ISNULL(TIPOAJRECEBER.IDAJUCTREC,0  ) = ISNULL(INSERTED.IDAJUCTREC,0  )) AND
            (ISNULL(TIPOAJRECEBER.IDCTBAJCTREC,0) = ISNULL(INSERTED.IDCTBAJCTREC,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATUTPAR_TIPOAJRECEBER','4.11.072';
GO

